assert( Necronomicon, "Necronomicon not found!")

----------------------------------
--        Are you local?        --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Necronomicon")

local istrading = nil
local accepttrade = nil
local hashealthstone = nil
local healthstonebag = nil
local healthstoneslot = nil

local healthstoneid = {
	[5512] = true,
	[19004] = true,
	[19005] = true,
	[5511] = true,
	[19006] = true,
	[19007] = true,
	[5509] = true,
	[19008] = true,
	[19009] = true,
	[5510] = true,
	[19010] = true,
	[19011] = true,
	[9421] = true,
	[19012] = true,
	[19013] = true,
	[22103] = true,
	[22104] = true,
	[22105] = true,
}

----------------------------------
--      Module Declaration      --
----------------------------------

NecronomiconHealthstone = Necronomicon:NewModule("Healthstone")

NecronomiconHealthstone.revision = tonumber(string.sub("$Revision: 26482 $", 12, -3))

NecronomiconHealthstone.defaults = {
}

----------------------------------
--     Module Intialization     --
----------------------------------

function NecronomiconHealthstone:OnRegister()
	self:RegisterSpell("Create Healthstone")
	for k, v in pairs( healthstoneid ) do
		self:RegisterItem( k )
	end

function NecronomiconHealthstone:OnEnable()
	self:RegisterEvent("Necronomicon_ClearSpells")
	self:RegisterEvent("Necronomicon_HasSpell")
	self:RegisterEvent("Necronomicon_BagUpdate")
	self:RegisterEvent("TRADE_SHOW")
	self:RegisterEvent("TRADE_REQUEST", "TRADE_SHOW")
	self:RegisterEvent("TRADE_CLOSED")
	self:RegisterEvent("TRADE_REQUEST_CANCEL", "TRADE_CLOSED")
	self:RegisterEvent("TRADE_ACCEPT_UPDATE")
end

----------------------------------
--        Event Handlers        --
----------------------------------

function NecronomiconHealthstone:Necronomicon_ClearSpells()
end

function NecronomiconHealthstone:Necronomicon_HasSpell( enspell, spell, subspell, spellid )
	if not enspell then return end
end

function NecronomiconHealthstone:TRADE_SHOW()
	istrading = true
end

function NecronomiconHealthstone:TRADE_CLOSED()
	istrading = nil
end

function NecronomiconHealthstone:TRADE_ACCEPT_UPDATE()
	if istrading and accepttrade 
		AcceptTrade()
		istrading = nil
		accepttrade = nil
	end
end

function NecronomiconHealthstone:Necronomicon_BagUpdate( itemid, bag, slot)
	if not itemid then return end
	if healthstoneid[itemid] then
	end
end

----------------------------------
--       Command Handlers       --
----------------------------------

function NecronomiconHealthstone:TradeHealthstone()
	if not hashealthstone then return end

	if istrading and not accepttrade then
		PickupContainerItem( healthstonebag, healthstoneslot)
		ClickTradeButton(1)
		accepttrade = true
	elseif UnitExists("target") and UnitIsPlayer("target") and UnitIsFriend("player","target") then
		PickupContainerItem( healthstonebag, healthstoneslot)
		if CursorHasItem() then
			DropItemOnUnit("target")
			accepttrade = true
		end
	end
end

