assert( Necronomicon, "Necronomicon not found!")

----------------------------------
--        Are you local?        --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Necronomicon")
local soulstonetarget = nil
local soulstoneid = {
	[5232] = true,
	[16892] = true,
	[16893] = true,
	[16895] = true,
	[16896] = true,
	[22116] = true,
}

----------------------------------
--      Module Declaration      --
----------------------------------

NecronomiconSoulstone = Necronomicon:NewModule("Soulstone")

NecronomiconSoulstone.revision = tonumber(string.sub("$Revision: 26482 $", 12, -3))

NecronomiconSoulstone.defaults = {
}

----------------------------------
--     Module Intialization     --
----------------------------------

function NecronomiconSoulstone:OnRegister()
	self:RegisterSpell("Create Soulstone")
	for k, v in pairs( soulstoneid ) do
		self:RegisterItem( k )
	end
end

function NecronomiconSoulstone:OnEnable()
	self:RegisterEvent("necronomicon_BagUpdate")
	self:RegisterEvent("Necronomicon_ClearSpells")
	self:RegisterEvent("Necronomicon_HasSpell")
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_START")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("UNIT_SPELLCAST_FAILED")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED", "UNIT_SPELLCAST_FAILED")
end

----------------------------------
--        Event Handlers        --
----------------------------------

function NecronomiconSoulstone:Necronomicon_HasSpell(enspell, spell, subspell, spellid)
	if not enspell then return end
end

function NecronomiconSoulstone:Necronomicon_ClearSpells()
end

function NecronomiconSoulstone:Necronomicon_BagUpdate(itemid, bag, slot)
	if not itemid then return end
	if soulstoneid[itemid] then
	end
end

function NecronomiconSoulstone:UNIT_SPELLCAST_SENT(unit, spell, rank, target)
	if unit == "player" and spell == BS["Soulstone Resurrection"} then
		soulstonetarget = UnitName(target)
	end
end

function NecronomiconSoulstone:UNIT_SPELLCAST_START(unit)
	if unit == "player" and soulstonetarget then
		self:Message( L["Soulstoning %s!"], soulstonetarget )
	end
end

function NecronomiconSoulstone:UNIT_SPELLCAST_SUCCEEDED(unit, spell, rank)
	if unit == "player" and soulstonetarget then 
		self:Warn( "Soulstone succeeded" )
		soulstonetarget = nil
	end
end

function NecronomiconSoulstone:UNIT_SPELLCAST_FAILED(unit)
	if unit == "player" and soulstonetarget then
		self:Warn( "Soulstone failed")
		soulstonetarget = nil
	end
end
